﻿using System.Windows.Forms;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Data.Common;
using System;
using VisTool;

namespace uVisStudio.VisDatamap
{
    partial class DataViewForm
    {
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void SetTitle(string title)
        {
            this.Text = title + " DataView";
        }

        private void updateSize()
        {
            this.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowOnly;
            this.Size = new System.Drawing.Size(50, 50);
            this.MinimumSize = new System.Drawing.Size(50, 50);
            this.MaximumSize = new System.Drawing.Size(Screen.PrimaryScreen.WorkingArea.Width - 100, Screen.PrimaryScreen.WorkingArea.Height - 100);

            int width = 0;
            foreach (DataGridViewColumn c in dataGridView1.Columns)
            {
                if (c.Visible)
                    width += c.Width;
            }
            int height = dataGridView1.RowCount * 25 + 25;

            //adjust the width
            if (height + 20 > this.MaximumSize.Height) this.Width = width + 76;
            else this.Width = width + 59;

            //adjust the height
            if (width + 58 > this.MaximumSize.Width) this.Height = height + 30;
            else this.Height = height + 24;

            System.Console.WriteLine("dgv height: " + dataGridView1.Height + " our height: " + height);
            System.Console.WriteLine("dgv width: " + dataGridView1.Width + " our width: " + width);
        }

        //TODO: Can this kind of thing be used for anything?
        private void dataGridView1_CellContentDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            DataGridView dgv = (DataGridView)sender;
            DataGridViewSelectedCellCollection cells = dgv.SelectedCells;
            if (cells.Count == 1)
            {
                string table_name = dgv.Columns[cells[0].ColumnIndex].Name;
                try { Table tbl = VisEngine.DataMaps[0].getTable(table_name); }
                catch (System.Exception) { MessageBox.Show("Couldnt find table named: " + table_name); return; }

                string where = " WHERE " + table_name + " = " + cells[0].ToString();
                DataViewForm dvtf2 = new DataViewForm();
                dvtf2.FillData(table_name);
            }
        }

        /// <summary>
        /// Get the whole table specified by table_name
        /// </summary>
        /// <param name="tabel_name"></param>
        public void FillData(string tabel_name)
        {
            SetTitle(tabel_name);
            //Create a connection
            using (OleDbConnection c = new OleDbConnection(
            VisEngine.DataMaps[0].ConnectionString))
            {
                //Open the connection
                c.Open();
                //Create a DataAdapter
                using (OleDbDataAdapter a = new OleDbDataAdapter("SELECT * FROM " + tabel_name, c))
                {
                    //Use the DataAdapter to fill a DataTable
                    DataTable t = new DataTable();
                    a.Fill(t);
                    //Make the datatable the Rows of the datagridview
                    //The datagridview is only displaying information held in the datatable
                    dataGridView1.DataSource = t;
                    //autosize the columns' width
                    dataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.AllCells);
                    dataGridView1.AllowUserToResizeColumns = true;

                    //TODO: could that thing be used for anything?
                    //dataGridView1.CellContentDoubleClick += new System.Windows.Forms.DataGridViewCellEventHandler(dataGridView1_CellContentDoubleClick);
                }
                c.Close();
            }
            updateSize();
        }



        /// <summary>
        /// Get data from a table with the specified conditions
        /// </summary>
        /// <param name="tabel_name"></param> 
        /// <param name="conditions"></param> e.g. " WHERE patientName = Jørgen Hansen"
        public void FillDataWithConditions(string tabel_name, string conditions)
        {
            SetTitle(tabel_name);
            //Create a connection
            using (OleDbConnection c = new OleDbConnection(
            VisEngine.DataMaps[0].ConnectionString))
            {
                //Open the connection
                c.Open();
                //Create a DataAdapter
                using (OleDbDataAdapter a = new OleDbDataAdapter("SELECT * FROM " + tabel_name + conditions, c))
                {
                    //Use the DataAdapter to fill a DataTable
                    DataTable t = new DataTable();
                    a.Fill(t);
                    //Make the datatable the Rows of the datagridview
                    dataGridView1.DataSource = t;
                    //dataGridView1.CellContentDoubleClick += new System.Windows.Forms.DataGridViewCellEventHandler(dataGridView1_CellContentDoubleClick);
                }
                c.Close();
            }
            updateSize();
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.dataGridView1 = new System.Windows.Forms.DataGridView();
            ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).BeginInit();
            this.SuspendLayout();
            // 
            // dataGridView1
            // 
            this.dataGridView1.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
            this.dataGridView1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.dataGridView1.Location = new System.Drawing.Point(0, 0);
            this.dataGridView1.Name = "dataGridView1";
            this.dataGridView1.Size = new System.Drawing.Size(341, 362);
            this.dataGridView1.TabIndex = 0;
            // 
            // DataViewForm
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(341, 362);
            this.Controls.Add(this.dataGridView1);
            this.Name = "DataViewForm";
            this.Text = "DataViewForm";
            ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).EndInit();
            this.ResumeLayout(false);

        }

        #endregion

        private System.Windows.Forms.DataGridView dataGridView1;
    }
}