﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace uVisStudio.VisToolbox
{
    public partial class VisToolboxGroup : UserControl
    {
        public List<VisToolboxItem> ToolboxItems { get; private set; }
        public bool IsExpanded { get; set; }

        public EventHandler IsExpandedChanged;

        public VisToolboxGroup()
		{
            ToolboxItems = new List<VisToolboxItem>();
            this.InitializeComponent();
            this.border.Background = ColorConstants.MenuBackGround();
            this.expandButton.Source = Properties.Resources.treeview_collapse.GetImage();
            this.expandButton.Stretch = Stretch.None;
		}

	    public VisToolboxGroup(string groupName) : this()
	    {
	        this.nameLabel.Content = groupName;
	    }

        private void ExpandButtonClicked(object sender, RoutedEventArgs routedEventArgs)
        {
            this.IsExpanded = !this.IsExpanded;
            this.expandButton.Source = this.IsExpanded ? ExtensionMethods.GetImage(Properties.Resources.treeview_collapse) : ExtensionMethods.GetImage(Properties.Resources.treeview_expand);
            this.IsExpandedChanged.Invoke(this, new EventArgs());
        }

        public void AddToolboxItem(VisToolboxItem toolboxItem)
        {
            this.ToolboxItems.Add(toolboxItem);
        }
    }
}
